// intraFont FuncTest
#include <pspkernel.h>
#include <stdio.h>
#include <string.h>
#include <pspgu.h>
#include <pspgum.h>
#include <pspdisplay.h>
#include <time.h>
#include <pspdebug.h>
#include <intraFont.h>

PSP_MODULE_INFO("intraFont FuncTest", PSP_MODULE_USER, 1, 1);
// 以下4行はguコマンド処理に必要
static unsigned int __attribute__((aligned(16))) list[262144];
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)
// メインルーチン
int main() {
	pspDebugScreenInit();
	// カラー定義
   	enum colors {
		RED = 0xFF0000FF,GREEN = 0xFF00FF00,BLUE = 0xFFFF0000,WHITE = 0xFFFFFFFF,
		LITEGRAY = 0xFFBFBFBF,GRAY = 0xFF7F7F7F,DARKGRAY = 0xFF3F3F3F,BLACK = 0xFF000000,
	};
	// ltn0～15フォント初期化＆ロード
	pspDebugScreenPrintf("Loading fonts..\n");
	intraFont* ltn[16];
	char file[40];
	int i;
	intraFontInit();
	for (i = 0; i < 16; i++) {
		sprintf(file, "flash0:/font/ltn%d.pgf", i); 
		ltn[i] = intraFontLoad(file,0);
	}
	// 日本語フォントをロード
    intraFont* jpn0 = intraFontLoad("flash0:/font/jpn0.pgf",INTRAFONT_STRING_SJIS);

	// GU初期化
	sceGuInit();
	sceGuStart(GU_DIRECT, list);
	sceGuDrawBuffer(GU_PSM_8888, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x88000, BUF_WIDTH);
	sceGuDepthBuffer((void*)0x110000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT);
	sceGuDepthRange(65535, 0);
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST);
	sceGuDepthFunc(GU_GEQUAL);
	sceGuEnable(GU_DEPTH_TEST);
	sceGuFrontFace(GU_CW);
	sceGuShadeModel(GU_SMOOTH);
	sceGuEnable(GU_CULL_FACE);
	sceGuEnable(GU_CLIP_PLANES);
	sceGuEnable(GU_BLEND);
	sceGuBlendFunc(GU_ADD, GU_SRC_ALPHA, GU_ONE_MINUS_SRC_ALPHA, 0, 0);
	sceGuFinish();
	sceGuSync(0,0);
	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);
	while(1){
		// 描画開始
		sceGuStart(GU_DIRECT, list);
		sceGumMatrixMode(GU_PROJECTION);
		sceGumLoadIdentity();
		sceGumPerspective( 75.0f, 16.0f/9.0f, 0.5f, 1000.0f);
        sceGumMatrixMode(GU_VIEW);
		sceGumLoadIdentity();
		sceGumMatrixMode(GU_MODEL);
		sceGumLoadIdentity();
		sceGuClearColor(WHITE); // 背景色
		sceGuClearDepth(0);
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
		intraFontSetEncoding(jpn0, INTRAFONT_STRING_UTF8);

		// intraFontSetStyle(フォント,サイズ,色,背景色,描画方法)
		intraFontSetStyle(jpn0  , 1.0f,BLACK,GREEN,INTRAFONT_ALIGN_LEFT);
		intraFontSetStyle(ltn[0], 1.0f,RED  ,BLUE ,INTRAFONT_ALIGN_LEFT);

		// intraFontPrint(フォント,X座標,Y座標,テキスト)
		// intraFontPrintEx(フォント,X座標,Y座標,テキスト,文字数)
		intraFontPrint(jpn0, 10,20, "黒文字＆緑背景");
		intraFontPrintEx(jpn0, 10,50, "あいうえお",3); // "あいう"だけ出力される

		// intraFontPrintColumn(フォント,X座標,Y座標,改行位置,autoBreakLine,テキスト)
		// intraFontPrintColumnEx(フォント,X座標,Y座標,改行位置,autoBreakLine,テキスト,文字数)
		intraFontPrintColumn(ltn[0], 50,80, 100,"intraFontPrintColumn");
		intraFontPrintColumnEx(ltn[0], 240,80, 280,"intraFontPrintColumnEx",20);
		
		// intraFontPrintf(フォント,X座標,Y座標,テキスト)
		unsigned long ulTestParam=838861;
		intraFontPrintf(jpn0,20,140,"日本語と数字%ldまぜまぜ",ulTestParam);

		// 描画終了
		sceGuFinish();
		sceGuSync(0,0);
		sceDisplayWaitVblankStart();
		sceGuSwapBuffers();
	}
	// 通常は上のループ脱出後にフォントをアンロードするように組む
	for (i = 0; i < 16; i++) {
		intraFontUnload(ltn[i]);
	}
	intraFontUnload(jpn0);
	intraFontShutdown();
	sceKernelExitGame();
	return 0;
}
